#include "gpio_pwm_carship.h"
#include "gpio_pwm_ptz.h"
#include "ip.h"
#include "mqtt.h"
#include "delay.h"
#include "opensh.h"
#include "INA226.h"
#include "pthrpoll.h"
#include "heat.h"
#include "common.h"
#include "device_exit.h"
#include "thread_main.h"

pthread_t thread[4];
//开启线程
int thread_start(void *AppExit(void *arg),void *Mqttbeat(void *arg),void *opensh(void *arg),void *Mqtt_onnect(void *arg)){
    if(pthread_create(&thread[0],NULL,AppExit,NULL)!=0) {
        //perror("Failed to create thread 0");
        my_zlog_error("Failed to create thread 0");
        return 1;
    }
    if(pthread_create(&thread[1],NULL,Mqttbeat,NULL)!=0) {
        //perror("Failed to create thread 1");
        my_zlog_error("Failed to create thread 1");
        return 2;
    }
    if(pthread_create(&thread[2],NULL,opensh,NULL)!=0){
        //perror("Failed to create thread 2");
        my_zlog_error("Failed to create thread 2");
        return 3;
    }
    if(pthread_create(&thread[3],NULL,Mqtt_onnect,NULL)!=0) {
        //perror("Failed to create thread 3");
        my_zlog_error("Failed to create thread 3");
        return 4;
    }
        return 0;
}


void *AppExit(void *arg) { //出现意外自动停止
    while(1){    
        Delay_Ms(0,100);
        gPwmCount++;
        if(gPwmCount>=5) {
        if(AppExit_pin_pwm==101) car_exit_0101();//车0101异常问题处理
        if(AppExit_pin_pwm==102) car_exit_0102();//车0102异常问题处理
        if(AppExit_pin_pwm==201) tank_exit_0201();//坦克0201异常问题处理  
        if(AppExit_pin_pwm==202) tank_exit_0202(); //坦克0202异常问题处理 
        if(AppExit_pin_pwm==301) ship_exit_0301();//船异0301常问题处理
        if(AppExit_pin_pwm==401) ptz_exit_0401();//炮异0401常问题处理
        gPwmCount=6;
        } 
    }
    return NULL; 
}

void *Mqttbeat(void *arg) { 
    //printf("Mqttbeat start\n");
    my_zlog_info("Mqttbeat start");
    Delay_Ms(15,0);
    while(1) {
        ipaddr();//获取ip
        Delay_Ms(3,0);
        mqtt_wirte();//心跳，3s一个        
    }
    return NULL;
}

void *opensh(void *arg) { 
    Delay_Ms(5,0);
    //printf("open cam\n");
    my_zlog_info("open cam");
    opencamsh();//10s后打开游览器并且进入网址
    return NULL; 
}

void *Mqtt_onnect(void *arg) {//mqtt异常处理，断开自动重连，简单粗暴
    Delay_Ms(5,0);
    mqtt_init();//mqtt初始化
    mqtt_create(mosq);//创建mqtt客户端
    while(1){
        mqtt_create(mosq);//创建mqtt客户端     
        mqtt_cycle(mosq); //进入mqtt死循环，异常退出继续执行while
    }
    mqtt_clean(mosq);
    return NULL;
}


// 等待线程结束
void thread_end() {
    pthread_join(thread[0], NULL);
    pthread_join(thread[1], NULL);
    pthread_join(thread[2], NULL);
    pthread_join(thread[3], NULL);
}

